﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
using HeuristicLab.Common;

namespace HeuristicLab.Hive.Contracts.BusinessObjects {

  [StorableClass]
  [DataContract]
  public class SlaveGroupDto : ResourceDto {
    [Storable]
    [DataMember]
    public List<ResourceDto> Resources { get; set; }

    public SlaveGroupDto() {
      Resources = new List<ResourceDto>();
    }
    [StorableConstructor]
    protected SlaveGroupDto(bool deserializing) : base(deserializing) { }
    protected SlaveGroupDto(SlaveGroupDto original, Cloner cloner)
      : base(original, cloner) {
      this.Resources = (original.Resources.Select(x => cloner.Clone(x))).ToList();
    }
    public override IDeepCloneable Clone(Cloner cloner) {
      return new SlaveGroupDto(this, cloner);
    }
  }
}
